import java.time.LocalDate;
import java.util.concurrent.atomic.AtomicReference;

public class Transaction implements AccountBook{
    private final AtomicReference<Integer> id = new AtomicReference<Integer>();
    private final AtomicReference<LocalDate> date = new AtomicReference<LocalDate>(LocalDate.now());
    private String memo;
    private Payee payee;
    private TransactionType typee; // Credit (reduces the checkbook), Debit (increases the checkbook)
    private Double amount;

    public Transaction(String memo, Payee payee, TransactionType typee, Double amount) {
        this.typee = typee;
        this.memo = memo;
        this.payee = payee;
        this.amount = ((typee.equals(TransactionType.DEBIT)) ? amount : (-1 * amount));
    }

    public LocalDate getDate() {
        return date.get();
    }

    public TransactionType getType() {
        return typee;
    }

    public String getMemo() {
        return memo;
    }

    public Payee getPayee() {
        return payee;
    }

    public Double getAmount() {
        return amount;
    }

    @Override
    public boolean equals(Object o) {
        Transaction otherTransaction = (Transaction) o;
        if(!(otherTransaction.getType() == typee))
            return false;
        if(!otherTransaction.getPayee().equals(payee))
            return false;
        if(!(otherTransaction.getAmount() == amount))
            return false;
        if(!otherTransaction.getMemo().equals(memo))
            return false;

        return true;
    }
}
